apiVersion: apps/v1
kind: DaemonSet
metadata:
  labels:
    app: csm-x100-hwmanager-ds
  name: csm-x100-hwmanager-ds
  namespace: x100-operator-resources
spec:
  selector:
    matchLabels:
      app: csm-x100-hwmanager-ds
  template:
    metadata:
      labels:
        app: csm-x100-hwmanager-ds
    spec:
      serviceAccount: csm-x100-sa
      serviceAccountName: csm-x100-sa
      securityContext:
        runAsUser: 0
      initContainers:
      - name: csm-x100-hwmanager-fwcp
        image: public.ecr.aws/docker/library/ubuntu:22.04
        securityContext:
          privileged: true
        command: ['bash', '-c', 'echo -n /var/lib/firmware > /sys/module/firmware_class/parameters/path']
        volumeMounts:
        - name: fwclasspath
          mountPath: /sys/module/firmware_class/parameters
      imagePullSecrets:
      - name: eks-pull-secret
      containers:
      - name: csm-x100-hwmanager
        image: <hwmanager container image>
        imagePullPolicy: Always
        securityContext:
          privileged: true
          runAsUser: 0
        lifecycle:
          preStop:
            exec:
              command: ["/bin/bash", "-c", "rm -rf /var/tmp/hwmgr-running"]
        env:
        - name: "SWVERSION_FROMCRD"
          value: "default"
        - name: "VFCOUNT"
          value: "4"
        volumeMounts:
        - mountPath: /var/lib/firmware/qcom/lassen
          name: hostpath-privileged
        - mountPath: /dev
          name: dev
        - mountPath: /var/log
          name: varlog
        - mountPath: /sys/fs/cgroup
          name: sysfscgroup
        - mountPath: /var/tmp
          name: csm-fconfig
        - mountPath: /diaglogs
          name: diaglogs
        - name: sys-bus
          mountPath: /sys/bus/pci/devices
        - name: sys-devices
          mountPath: /sys/devices
        - name: podcheck
          mountPath: /var/podcheck
      - name: csm-x100-hwmanager-logs1
        image: public.ecr.aws/docker/library/ubuntu:22.04
        imagePullPolicy: IfNotPresent
        volumeMounts:
        - name: varlog
          mountPath: /var/log
        args:
        - /bin/bash
        - -c
        - "tail -n+1 -F /var/log/QSaharaServer_0.log /var/log/QSaharaServer_1.log /var/log/QSaharaServer_2.log  /var/log/QSaharaServer_3.log /var/log/csm_device_0.log /var/log/csm_device_1.log /var/log/csm_device_2.log /var/log/csm_device_3.log"
      - name: csm-x100-hwmanager-logs2
        image: public.ecr.aws/docker/library/ubuntu:22.04
        imagePullPolicy: IfNotPresent
        volumeMounts:
        - name: varlog
          mountPath: /var/log
        args:
        - /bin/bash
        - -c
        - "tail -n+1 -F /var/log/device0/journal.log /var/log/device1/journal.log /var/log/device2/journal.log /var/log/device3/journal.log"
      - name: csm-x100-exporter
        image: <exporter container image>
        imagePullPolicy: Always
        ports:
        - name: x100-exporter
          containerPort: 9445
        volumeMounts:
        - name: varlog
          mountPath: /var/log
        args:
        - python3
        - /usr/bin/exporter.py
        - -i 10
        - -p 9445
      hostNetwork: true
      volumes:
      - name: fwclasspath
        hostPath:
          path: /sys/module/firmware_class/parameters
      - name: hostpath-privileged
        hostPath:
          path: /var/lib/firmware/qcom/lassen
      - name: dev
        hostPath:
          path: /dev
      - name: sysfscgroup
        hostPath:
          path: /sys/fs/cgroup
          type: Directory
      - name: podcheck
        emptyDir: {}
      - name: diaglogs
        hostPath:
          path: /var/log/diagfwdlogs
          type: DirectoryOrCreate
      - name: varlog
        emptyDir: {}
      - name: sys-bus
        hostPath:
          path: /sys/bus/pci/devices
          type: Directory
      - name: sys-devices
        hostPath:
          path: /sys/devices
          type: Directory
      - name: csm-fconfig
        hostPath:
          path: /tmp
          type: Directory
      nodeSelector:
        qualcomm.com/x100.present: "true"
